#
# Copyright (c) 2008-2015 Thierry Florac <tflorac AT ulthar.net>
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#

__docformat__ = 'restructuredtext'


# import standard library

# import interfaces
from pyams_pagelet.interfaces import IPagelet
from pyams_portal.interfaces import IPortletPreviewer, IPortalPage, IPortalTemplate, IPortalTemplateConfiguration
from pyams_portal.portlets.image.interfaces import IImagePortletSettings
from pyams_skin.layer import IPyAMSLayer
from pyams_utils.interfaces import VIEW_SYSTEM_PERMISSION

# import packages
from pyams_form.form import AJAXEditForm
from pyams_pagelet.pagelet import pagelet_config
from pyams_portal.portlet import PortletPreviewer
from pyams_portal.zmi.portlet import PortletSettingsEditor
from pyams_template.template import template_config
from pyams_utils.adapter import adapter_config
from zope.interface import Interface


@pagelet_config(name='properties.html', context=IImagePortletSettings, request_type=IPyAMSLayer,
                permission=VIEW_SYSTEM_PERMISSION)
class ImagePortletSettingsEditor(PortletSettingsEditor):
    """Image portlet settings editor"""

    settings = IImagePortletSettings


@adapter_config(name='properties.json', context=(IImagePortletSettings, IPyAMSLayer), provides=IPagelet)
class ImagePortletConfigurationAJAXEditor(AJAXEditForm, ImagePortletSettingsEditor):
    """Image portlet settings editor, AJAX renderer"""


@adapter_config(context=(Interface, IPyAMSLayer, Interface, IImagePortletSettings), provides=IPortletPreviewer)
@template_config(template='templates/image-preview.pt', layer=IPyAMSLayer)
class ImagePortletPreviewer(PortletPreviewer):
    """Image portlet previewer"""
